# Keyboard Shortcuts

One thing that might not be immediately obvious if you’re new to this is the naming convention that’s commonly used.

- <kbd>M-x</kbd> means <kbd>OPTION</kbd> + <kbd>x</kbd> keys. The `meta` or `M` key is mapped to the option key on most systems today. 
- <kbd>C-u</kbd> refers to <kbd>CONTROL</kbd> + <kbd>u</kbd> 
- When there is no dash, you're looking at a chord. The keys are then pressed in sequence.
- When you see a capital <kbd>S</kbd> that usually means the `SHIFT` key, unless someone used a capital “s” in their function shortcut.
- Oh yes and <kbd><spc></kbd> or <kbd>SPC</kbd> that’s just the space bar.


## Custom Function Shortcuts

### Writing Setup
 
- <kbd>F3</kbd>  :  *(write-window-setup)* 
	1. Create window layout
	2. Load or create the file `draft.org`
	3. Load or create the file `notes.md`

***

### Set Window Margins
 
- <kbd>F5</kbd>  :  *(my-toggle-margins-low)*
	- Sets the text-to-window margin low, useful for narrow window columns.

	***

- <kbd>F8</kbd>  :  *(my-toggle-margins-wide)*
	- Sets the text-to-window margin wider, easier on the eyes for wider window columns.

***

### Org-Mode
 
- <kbd>F7</kbd>  :  *(org-html-export-to-html)*
	- Create a formatted webpage of your document in the same folder you’re working in.

	***

- <kbd>F9</kbd>  :  *(split-and-indirect-orgtree)*
	- Create a new window with an isolated view of the outline element you have currently selected.

	***

- <kbd>F12</kbd> :  *(kill-and-unsplit-orgtree)*
	- Remove the currently selected isolated view and collapse the window.

***

## Evil Keys
 
- [Evil-mode Cheat-Sheet](https://github.com/jbranso/cheatsheets/blob/master/evil.org)
- [Evil Overview](https://www.emacswiki.org/emacs/Evil)

***

## Emacs Keys
 
- [Emacs Keyboard Commands](https://www.gnu.org/software/emacs/refcards/pdf/refcard.pdf) (US)
- [Emacs Survival Card](https://www.gnu.org/software/emacs/refcards/pdf/survival.pdf) (US)
- [Org-Mode Commands](https://www.gnu.org/software/emacs/refcards/pdf/orgcard.pdf) (US)
- [Collected Works](https://www.gnu.org/software/emacs/refcards/index.html) (Multi-Language)
